;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Effect Name : gain
;
; Description : simple gain applied to signal
;
; Nb In       :	1
; Nb Out      : 1
;
; Input       : 1 channel signal
; Output      : amplified signal
;
; Cycles      : 3 + 6 cycles (-1=unknownw)
; Memory      : 1 words (without init)
; Delay Line  :	no
;
; Author      : Gregor
; Date        : 24/10/2002
; Version     : 1.0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ABS	INIT	0x3FF
	
	;; SEC1 Control parameters
ABS	Gain	0x0
		
	;; SEC2 Initial values of control parameters (S3.24 format)
IGain	EQU	0x200000
	
	;; SEC3 Constants definitions

	;; SEC4 Memory variables definition

	;; SEC5 Initial values of memory variables

	;; SEC6 Initialization
CM	0x40000	INIT
SKIP	!Z	EndInit
1AC	IGain			; initial default gain value
SCA	0x0 Gain
C       0x1000000		; 1->A
SCA     0x0     INIT		; do not reinitialize next time
EndInit:

	;; SEC7 Module code
CM	0x40000 IN1		; load input
AMC	0x0 Gain		; amplify
SCA	0x0 OUT1		; write output and restore 0 in A
