#ifndef __EXTRACT_H__
#define __EXTRACT_H__

#include "../common/1K_types.h"

// extract hexadecimal constant from a given string
// the allowed formats are 
//     -  0X...   Hexadecimal format
//     -  $...    Hexadecimal format
//     -  ...h    Hexadecimal format
//     -  %...    Binary format
//     -  ...B    Binary format
//     -  ...Q    Octal format
//     -  Integer and floating point formats.
// returns 0 if success, 1 if an error is detected in the constant format
// if the function succeed, the constant is stored in 'cst'
// 'nmant' contains the expectes number of bits after the decimal point.
// if nmant<=0, the constant has to be an integer
// (decimal or hexadecimal format).
// if nmant==-1 (NMANT_ADDR), we directly ask for an address 
// (i.e. we call preasm with CST_ABS when required)
// if nmant==-2 (NMANT_LABEL), we allow for a CST_EQU or a Label
int ExtractHexa(char *String, UINT32 *cst, int nmant);


#endif
