/////////////////////////////////////////////////////////////////////////////
// Name:        AL3101EditProperties.cpp
// Project:     GUI for Axoris AL3101 application generator
// Author:      Gregor(y) Soyez
// Version:     1.0
// Created:     24/11/02
// Copyright:   (c) 2002 Axoris
/////////////////////////////////////////////////////////////////////////////

#include "AL3101EditProperties.h"

// ID's
#define ID_STATIC     1
#define ID_PROP_BASE 10

#include <wx/stattext.h>
#include <wx/textctrl.h>

//-----------------------------------------------------
// implementation of CProperties
//-----------------------------------------------------

CProperties::CProperties(wxWindow* parent, wxWindowID id, TModuleProperty *p, int NbProperties)
  : wxDialog(parent, id, "Properties", wxDefaultPosition, wxSize(250,170), wxDEFAULT_DIALOG_STYLE){
#ifdef DEBUG
  fprintf(stderr, "DBG: properties: Entering constructor\n");
#endif
  int i;

  // creates all widgets inside the dialog box
  TxtIntro = new wxStaticText(this, ID_STATIC, 
			      "Enter the properties for selected module" , 
			      wxPoint( 13, 10), wxSize(247, 20));

  TxtProp = new wxStaticText*[NbProperties];
  EdtProp = new wxTextCtrl*[NbProperties];
  sProp= new wxString[NbProperties];

  for (i=0;i<NbProperties;i++){
    TxtProp[i] = new wxStaticText(this, ID_STATIC, wxString(p[i].Name), 
				  wxPoint( 15, 50+25*i), wxSize(140, 20));
    sProp[i] << (p[i].Value);
    EdtProp[i] = new wxTextCtrl(this, ID_PROP_BASE+i, sProp[i],
				wxPoint(160, 50+25*i), wxSize(100, 20), 0,
				wxTextValidator(wxFILTER_ASCII, &(sProp[i])));
    if (strlen(p[i].Descr)!=0)
      EdtProp[i]->SetToolTip(p[i].Descr);
    else
      EdtProp[i]->SetToolTip("No description available");
  }

  BtnOk = new wxButton(this, wxID_OK, "Ok", 
		       wxPoint(50, 55+25*NbProperties), wxSize(50, 20));
  BtnCancel = new wxButton(this, wxID_CANCEL, "Cancel", 
			   wxPoint(150, 55+25*NbProperties), wxSize(50, 20));

  SetClientSize(350,87+25*NbProperties);
}


CProperties::~CProperties(){
#ifdef DEBUG
  fprintf(stderr, "DBG: directories: Entering destructor\n");
#endif
}
