////////////////////////////////////////////////////////////////
// Name:        Config.h                                      //
// Project:     GUI for Axoris AL3101 application generator   //
// Author:      Gregor(y) Soyez                               //
// Version:     1.0                                           //
// Created:     18/05/02                                      //
// Copyright:   (c) Axoris                                    //
////////////////////////////////////////////////////////////////

#ifndef __PROJAL_CONFIG__H__
#define __PROJAL_CONFIG__H__

#include <wx/config.h>

class CConfig{
 public:
  CConfig();
  ~CConfig();

  // window size
  int WindowWidth, WindowHeight;

  // frames size
  int StructWidth, StructHeight;

  // current project
  char *ProjectName;

  // directories
  char *EffectsDir;
  char *AssemblerDir;
  char *ProjectDir;
  char *SkinDir;

  // options
  int AsmVerbose;
  int MkVerbose;
  int MkMemMap;
  char *SkinName;

 private:
  wxConfig *config;
  int Exists;
  
  int Check();
  int Create();
  int Load();
  int Save();
};

#endif

