/////////////////////////////////////////////////////////////////////////////
// Name:        about.cpp
// Project:     GUI for Axoris AL3101 application generator
// Author:      Gregor(y) Soyez
// Version:     1.1
// Created:     05/01/02
// Copyright:   (c) Axoris
/////////////////////////////////////////////////////////////////////////////

#include "ProjectInfo.h"

// ID's
#define ID_STATIC 1
#define ID_NAME   2 
#define ID_DESCR  3
#define ID_IDESCR 4
#define ID_ODESCR 5
#define ID_NBIN   6
#define ID_NBOUT  7

#include <wx/stattext.h>
#include <wx/textctrl.h>

//-----------------------------------------------------
// implementation of CAbout
//-----------------------------------------------------

CProjectInfo::CProjectInfo(wxWindow* parent, wxWindowID id, TModuleInfo *p)
  : wxDialog(parent, id, "Prolect informations", wxDefaultPosition, wxSize(250,170), wxDEFAULT_DIALOG_STYLE){
#ifdef DEBUG
  fprintf(stderr, "DBG: project info: Entering constructor\n");
#endif

  pi = p;

  SetClientSize(315,250);
 
  // creates all widgets inside the dialog box
  TxtIntro = new wxStaticText(this, ID_STATIC, "Projetc informations" , wxPoint( 15, 10), wxSize(210, 20));
 
  Name   << p->Name;
  Descr  << p->Descr;
  IDescr << p->InDescr;
  ODescr << p->OutDescr;
  In     << p->NbIn;
  Out    << p->NbOut;
 
  TxtName = new wxStaticText(this, ID_STATIC, "Name:", wxPoint( 15, 40), wxSize(90, 24));
  EdtName = new wxTextCtrl(this, ID_NAME, Name, wxPoint(100, 40), wxSize(200, 24),
			   0, wxTextValidator(wxFILTER_ASCII, &Name));
 
  TxtDescr = new wxStaticText(this, ID_STATIC, "Description:", wxPoint( 15, 75), wxSize(90, 24));
  EdtDescr = new wxTextCtrl(this, ID_DESCR, Descr, wxPoint(100, 75), wxSize(200, 24),
			    0, wxTextValidator(wxFILTER_ASCII, &Descr));

  TxtNbIn = new wxStaticText(this, ID_STATIC, "Nb Inputs:", wxPoint( 15,110), wxSize(90,24));
  EdtNbIn = new wxTextCtrl(this, ID_NBIN, In, wxPoint(100, 110), wxSize(35,24),
			   0, wxTextValidator(wxFILTER_NUMERIC, &In));

  TxtNbOut = new wxStaticText(this, ID_STATIC, "Nb Outputs:", wxPoint(165,110), wxSize(90,24));
  EdtNbOut = new wxTextCtrl(this, ID_NBIN, In, wxPoint(260, 110), wxSize(35,24),
			   0, wxTextValidator(wxFILTER_NUMERIC, &Out));

  TxtIDescr = new wxStaticText(this, ID_STATIC, "Input Description:", wxPoint( 15,145), wxSize(140, 24));
  EdtIDescr = new wxTextCtrl(this, ID_DESCR, IDescr, wxPoint(150,145), wxSize(150, 24),
			    0, wxTextValidator(wxFILTER_ASCII, &IDescr));

  TxtODescr = new wxStaticText(this, ID_STATIC, "Output Description:", wxPoint( 15,180), wxSize(140, 24));
  EdtODescr = new wxTextCtrl(this, ID_DESCR, IDescr, wxPoint(150,180), wxSize(150, 24),
			    0, wxTextValidator(wxFILTER_ASCII, &ODescr));

  BtnOk = new wxButton(this, wxID_OK, "Ok", wxPoint(63, 215), wxSize(63, 24));
  BtnCancel = new wxButton(this, wxID_CANCEL, "Cancel", wxPoint(189, 215), wxSize(63, 20));
}

CProjectInfo::~CProjectInfo(){
#ifdef DEBUG
  fprintf(stderr, "DBG: project info: Entering destructor\n");
#endif

  sprintf(pi->Name, Name.c_str());
  sprintf(pi->Descr, Descr.c_str());
  sprintf(pi->InDescr, IDescr.c_str());
  sprintf(pi->OutDescr, ODescr.c_str());
  sscanf(In.c_str(), "%d", &(pi->NbIn));
  sscanf(Out.c_str(), "%d", &(pi->NbOut));

}
