/////////////////////////////////////////////////////////////////////////////
// Name:        about.cpp
// Project:     GUI for Axoris AL3101 application generator
// Author:      Gregor(y) Soyez
// Version:     1.1
// Created:     05/01/02
// Copyright:   (c) Axoris
/////////////////////////////////////////////////////////////////////////////

#include "about.h"

// ID's
#define ID_DESCR  1
#define ID_AUTH   2
#define ID_VER    3
#define ID_CPY    4
#define ID_CPYR   5

#include <wx/stattext.h>

//-----------------------------------------------------
// implementation of CAbout
//-----------------------------------------------------

CAbout::CAbout(wxWindow* parent, wxWindowID id)
  : wxDialog(parent, id, "About AGAD", wxDefaultPosition, wxSize(250,180), wxDEFAULT_DIALOG_STYLE){
#ifdef DEBUG
  fprintf(stderr, "DBG: about: Entering constructor\n");
#endif

  // creates all widgets inside the dialog box
  HdrDescr = new wxStaticText(this, ID_DESCR, "Description:" , wxPoint( 15, 10), wxSize(120, 20));
  TxtDescr = new wxStaticText(this, ID_DESCR, ABOUT_DESCRIPT , wxPoint(105, 10), wxSize(120, 40));

  HdrAuth  = new wxStaticText(this, ID_DESCR, "Author:"      , wxPoint( 15, 50), wxSize(120, 20));
  TxtAuth  = new wxStaticText(this, ID_DESCR, ABOUT_AUTHOR   , wxPoint(105, 50), wxSize(120, 20));

  HdrVer   = new wxStaticText(this, ID_DESCR, "Version:"     , wxPoint( 15, 70), wxSize(120, 20));
  TxtVer   = new wxStaticText(this, ID_DESCR, ABOUT_VERSION  , wxPoint(105, 70), wxSize(120, 20));

  HdrCpy   = new wxStaticText(this, ID_DESCR, "Company:"     , wxPoint( 15, 90), wxSize(120, 20));
  TxtCpy   = new wxStaticText(this, ID_DESCR, ABOUT_COMPANY  , wxPoint(105, 90), wxSize(120, 20));

  TxtCpyr  = new wxStaticText(this, ID_DESCR, ABOUT_COPYRIGHT, wxPoint( 15,120), wxSize(180, 20));

  BtnOk = new wxButton(this, wxID_OK, "Ok", wxPoint(100, 150), wxSize(50, 20));
}

CAbout::~CAbout(){
#ifdef DEBUG
  fprintf(stderr, "DBG: about: Entering destructor\n");
#endif

}
