/////////////////////////////////////////////////////////////////////////////
// Name:        fileio.h
// Project:     GUI for Axoris AL3101 application generator
// Author:      Gregor(y) Soyez
// Version:     1.1
// Created:     06/01/02
// Copyright:   (c) Axoris
/////////////////////////////////////////////////////////////////////////////

#ifndef __PROJ_AL_FILEIO_H__
#define __PROJ_AL_FILEIO_H__

#include <stdio.h>
#include <wx/wx.h>
#include "glmodulelist.h"
#include "link.h"
#include "../AL3101ModuleHeader.h"

class CFile{
 public:
  CFile(CglModuleList*, CLinkList*, int, wxFrame*);
  ~CFile();

  int SetOffset(int);

  void OnQuit();

  int New();
  int Open(char*);
  int Open();
  int Save();
  int SaveAs();

  char Name[512];
  TModuleInfo info;
  int IsModified;

 private:
  int NewFile;
  int offset;
  CglModuleList *mods;
  CLinkList *links;
  wxFrame *MainFrame;

  int PerformNew();
  int ReadProjectInfo(FILE *);
  int SaveProjectInfo(FILE *);
};

#endif
