#include "print.h"
#include "gldefs.h"

inline double scales_min(double a, double b){
  return (a>b) ? b : a;
}

CPrintStruct::CPrintStruct(CglModuleList *iModList, wxString i_title)
  :wxPrintout(i_title){

  title = i_title;
  ModList = iModList;
}

bool CPrintStruct::OnPrintPage(int page){
  wxDC *dc = GetDC();
  
  if (dc){
    //dc->SetUserScale(1.0, 1.0);
        
    //wxChar buf[200];
    //wxSprintf(buf, wxT("PAGE %d"), page);
    // dc->DrawText(buf, 10, 10);

    Draw(dc);

    return TRUE;
  }
  
  return FALSE;
}

bool CPrintStruct::OnBeginDocument(int startPage, int endPage){
  if (!wxPrintout::OnBeginDocument(startPage, endPage))
    return FALSE;
  
  return TRUE;
}

void CPrintStruct::GetPageInfo(int *minPage, int *maxPage, int *selPageFrom, int *selPageTo){
  *minPage = 1;
  *maxPage = 1;
  *selPageFrom = 1;
  *selPageTo = 1;
}

bool CPrintStruct::HasPage(int pageNum){
  return (pageNum == 1);
}

void CPrintStruct::Draw(wxDC *dc){
  wxCoord w, h;
  TglModuleList *ml;
 
  dc->GetSize(&w, &h);
  fprintf(stdout, "Page is %d x %d\n", w, h);

  dc->SetBrush(* wxLIGHT_GREY_BRUSH);
  dc->SetPen(* wxBLACK_PEN);

  // print title
  wxFont TitleFont(14, wxROMAN, wxNORMAL, wxBOLD);
  dc->SetFont(TitleFont);
  dc->DrawText(title, 10, 10);

  // compute scale
  double scaleX=0.0;
  double scaleY=0.0;
  int maxx=0, maxy=0;
  ml = ModList->List;
  while (ml!=NULL){
    if (ml->Mod->x+ml->Mod->nx > maxx) maxx=ml->Mod->x+ml->Mod->nx;
    if (ml->Mod->y+ml->Mod->ny > maxy) maxy=ml->Mod->y+ml->Mod->ny;
    ml = (TglModuleList*) ml->Next;
  };

  double dw = w;
  double dh = h;
  scaleX = dw/(SIZE_OF_GRID*(maxx+2.0));
  scaleY = dh/(SIZE_OF_GRID*(maxy+2.0));

  dc->SetUserScale(scales_min(scaleX,scaleY),scales_min(scaleX,scaleY));
  dc->SetDeviceOrigin(0, 20);
  
  ModList->Render(dc, 0);
}
