/////////////////////////////////////////////////////////////////////////////
// Name:        simulate.h
// Project:     GUI for Axoris AL3101 application generator
// Author:      Gregor(y) Soyez
// Version:     1.0
// Created:     23/03/03
// Copyright:   (c) 2003 Axoris
/////////////////////////////////////////////////////////////////////////////

#ifndef __PROJ_AL_SIMULATE_H__
#define __PROJ_AL_SIMULATE_H__

// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

// for all others, include the necessary headers (this file is usually all you
// need because it includes almost all "standard" wxWindows headers)
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

// controls identifiers
//---------------------
#define ID_STATIC     1
#define ID_EDT_INWAV  2
#define ID_EDT_OUTWAV 3
#define ID_BTN_INWAV  4
#define ID_BTN_OUTWAV 5
#define ID_SIMULATE   6
#define ID_SIMCONSOLE 7

// simulation dialog-box class
//----------------------------
class CSimulate : public wxDialog{
  //DECLARE_DYNAMIC_CLASS(Simul)

 public:
  // ctor & dtor
  CSimulate(wxWindow* parent, wxWindowID id, char*);
  ~CSimulate();

  void OnBrowseInWav (wxCommandEvent &e);
  void OnBrowseOutWav(wxCommandEvent &e);
  void OnSimulate(wxCommandEvent &e);

 private:
  char AsmFile[255];
  wxString InWavName, OutWavName;
  wxButton *BtnInBrowse, *BtnOutBrowse;
  
  wxButton *BtnSimulate, *BtnOk, *BtnCancel;
  wxStaticText *TxtInWav, *TxtOutWav;
  wxTextCtrl *EdtInWav, *EdtOutWav;
  wxTextCtrl *SimConsole;

  DECLARE_EVENT_TABLE()
};

#endif
