/////////////////////////////////////////////////////////////////////////////
// Name:        AL3101DealProperties.cpp
// Project:     GUI for Axoris AL3101 application generator
// Author:      Gregor(y) Soyez
// Version:     1.0
// Created:     24/11/02
// Copyright:   (c) 2002 Axoris
/////////////////////////////////////////////////////////////////////////////

#include "messages.h"
#include "properties.h"
#include <string.h>
#include "extract.h"

int UpCase(char *s){
  int i, l=strlen(s);
  for (i=0;i<l;i++) 
    if ((s[i]>='a') && (s[i]<='z')){
      s[i]-=('a'-'A');
    }

  return 0;
}

// scan file to search for section 2
// Then fill the properties array for that module
// We return 0 on success 1 on error
int GetPropertyArray(FILE *flux, long int *SecOffsets, TMemoryMap **map){
  char Line[255], PropName[255], PropId[255], PropValue[255];
  int i, sec;
  UINT32 val;
  TMemoryMap *map2add;
  
  // scanning SEC1 abd SEC4 addresses
  for (sec = 0;sec<=3;sec+=3){
    fseek(flux, SecOffsets[sec], SEEK_SET);
    while(ftell(flux)<SecOffsets[sec+1]){
      // read line from file, split it and check that it has the form
      // ABS <name> <value>
      if (fgets(Line,255,flux)==NULL){
	OUTPUT("Error while reading file\n");
	return 1;
      }
      i=sscanf(Line, "%s %s %s", PropId, PropName, PropValue);
      if (i==3){
	if ((strcmp(PropId, "ABS")==0) || 
	    (strcmp(PropId, "Abs")==0) || 
	    (strcmp(PropId, "abs")==0)){
	  // correct property
	  UpCase(PropValue);
	  if (ExtractHexa(PropValue, &val, 0)!=0){
	    OUTPUT1("Invalid address '%s'\n", PropValue);
	  } else {
	    map2add = new TMemoryMap;
	    strcpy(map2add->Name, PropName);
	    map2add->Addr = val;
	    map2add->Value = 0;
	    map2add->next = (*map);
	    if (sec==0) map2add->type = PROP_TYPE_PARAMETER; 
	    else map2add->type = PROP_TYPE_INTERNAL; 
	    (*map) = map2add;
	  }
	}
      }
    };
  }

  // catching corresponding initial values in SEC 2 and 5
  for (sec = 1;sec<=4;sec+=3){
    fseek(flux, SecOffsets[sec], SEEK_SET);
    while(ftell(flux)<SecOffsets[sec+1]){
      // read line from file, split it and check that it has the form
      // ABS <name> <value>
      if (fgets(Line,255,flux)==NULL){
	OUTPUT("Error while reading file");
	return 1;
      }
      i=sscanf(Line, "%s %s %s", PropName, PropId, PropValue);
      if (i==3){
	if ((strcmp(PropId, "EQU")==0) || 
	    (strcmp(PropId, "Equ")==0) || 
	    (strcmp(PropId, "equ")==0)){
	  // correct property
	  UpCase(PropValue);
	  if (ExtractHexa(PropValue, &val, 24)!=0){
	    OUTPUT1("Invalid value '%s'\n", PropValue);
	  } else if ((PropName[0]!='I') && (PropName[0]!='i')){
	    VERBOSE("Initialization value must be prefixed by 'I'.\n");
	  } else {
	    // search the corresponding address
	    map2add=(*map);
	    while (map2add!=NULL){
	      if (strcmp(map2add->Name, PropName+1)==0){
		VERY_VERBOSE3("\tName='%s', Address=%X, Value=%X\n", map2add->Name, map2add->Addr, val);
		map2add->Value = val;
	      }
	      map2add=map2add->next;
	    };
	  }
	}
      }
    };
  }

  return 0;
}
