#ifndef __DISASM_FUNC_H__
#define __DISASM_FUNC_H__

#include "../../common/1K_types.h"

#define CST_FORMAT_HEXADECIMAL 0
#define CST_FORMAT_DECIMAL     1

int SetConstantFormat(int format);

//                                               3210987654321098765432109876543210
// normal mnemonics (no extrabit, no condition)
int disasm_c18_x_m(UINT32, UINT32, char*);    // CCCCCCCCCCCCCCCCCCCCCCXMMMMMMMMMMM
int disasm_x_m    (UINT32, UINT32, char*);    // XXXXXXXXXXXXXXXXXXXXXXXMMMMMMMMMMM
int disasm_c24_x  (UINT32, UINT32, char*);    // CCCCCCCCCCCCCCCCCCCCCCCCCCCCXXXXXX
int disasm_c18_x  (UINT32, UINT32, char*);    // CCCCCCCCCCCCCCCCCCCCCCXXXXXXXXXXXX
int disasm_c18_d8 (UINT32, UINT32, char*);    // CCCCCCCCCCCCCCCCCCCCCCDDDDDDDDDDDD
int disasm_c8_d18 (UINT32, UINT32, char*);    // CCCCCCCCCCCCDDDDDDDDDDDDDDDDDDDDDD
int disasm_x      (UINT32, UINT32, char*);    // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

// mnemonics with condition
int disasm_c24_x_p(UINT32, UINT32, char*);    // CCCCCCCCCCCCCCCCCCCCCCCCCCCCXXPPPP
int disasm_c8_x_p (UINT32, UINT32, char*);    // CCCCCCCCXXXXXXXXXXXXXXXXXXXXXXPPPP

// mnemonics with extra bit
int disasm_c10_x_b_m(UINT32, UINT32, char*);  // CCCCCCCCCCXXXXXXXXXXXXbMMMMMMMMMMM
int disasm_c24_b_x  (UINT32, UINT32, char*);  // CCCCCCCCCCCCCCCCCCCCCCCCCCCC1XXXXX or
                                              // XXXXXXXXXXXXXXXXXXXXXXXXXXXX0XXXXX

#endif
