#include "AL3101AsmDisasmUtils.h"

/* 32 bits extension.
** All floating point constants in the structure are aligned on S3.24
** If the sign bit is 1 (negative number), we turn the last 4 bits 
** on the right to 1. This allows direct calculation in simulation functions.
*/
int ExtendTo32Bits(INT32 *c){
  if (((*c) & 0x8000000) != 0)
    (*c)+=0xF0000000;

  return 0;
}

/* If you try to write to addresses 0x410 to 0x417, 
** redirect it to 0x430 to 0x437
** This works for opcodes from to 0x100000 (SCA) to 0x110110 (S1BC).
** The "offset test" for SINDF and SINDI is not important since it they
** only affect addresses in the range 0x0 - 0x3FF
** This trick is used olny in the simulator version of the assembler,
** it is not part of the Alesis assembler syntax itself.
*/
int SimulatorOutputOffset(INT32 OpCode, INT32 *MemAddr){

  if (((OpCode<=54) && (OpCode>=32))
      && (((*MemAddr)<=1047) && ((*MemAddr)>=1040))){
    (*MemAddr)+=32;
  }

  return 0;
}
