#ifndef __ASM_FUNC_H__
#define __ASM_FUNC_H__

#include "AL3101Struct.h"

// pointer to an assembly function
typedef int (asm_func_ptr)(int, char**, AL3101_Disasm_struct*);

//                                                         3210987654321098765432109876543210
// normal mnemonics (no extrabit, no condition)
int asm_c18_x_m(int, char**, AL3101_Disasm_struct*);    // CCCCCCCCCCCCCCCCCCCCCCXMMMMMMMMMMM
int asm_x_m    (int, char**, AL3101_Disasm_struct*);    // XXXXXXXXXXXXXXXXXXXXXXXMMMMMMMMMMM
int asm_c24_x  (int, char**, AL3101_Disasm_struct*);    // CCCCCCCCCCCCCCCCCCCCCCCCCCCCXXXXXX
int asm_c18_x  (int, char**, AL3101_Disasm_struct*);    // CCCCCCCCCCCCCCCCCCCCCCXXXXXXXXXXXX
int asm_c18_d8 (int, char**, AL3101_Disasm_struct*);    // CCCCCCCCCCCCCCCCCCCCCCDDDDDDDDDDDD
int asm_c8_d18 (int, char**, AL3101_Disasm_struct*);    // CCCCCCCCCCCCDDDDDDDDDDDDDDDDDDDDDD
int asm_x      (int, char**, AL3101_Disasm_struct*);    // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

// mnemonics with condition
int asm_c24_x_p(int, char**, AL3101_Disasm_struct*);    // CCCCCCCCCCCCCCCCCCCCCCCCCCCCXXPPPP
int asm_c8_x_p (int, char**, AL3101_Disasm_struct*);    // CCCCCCCCXXXXXXXXXXXXXXXXXXXXXXPPPP

// mnemonics with extra bit
int asm_c10_x_0_m(int, char**, AL3101_Disasm_struct*);  // CCCCCCCCCCXXXXXXXXXXXX0MMMMMMMMMMM
int asm_c10_x_1_m(int, char**, AL3101_Disasm_struct*);  // CCCCCCCCCCXXXXXXXXXXXX1MMMMMMMMMMM
int asm_x_0_x    (int, char**, AL3101_Disasm_struct*);  // XXXXXXXXXXXXXXXXXXXXXXXXXXXX0XXXXX
int asm_c24_1_x  (int, char**, AL3101_Disasm_struct*);  // CCCCCCCCCCCCCCCCCCCCCCCCCCCC1XXXXX

#endif
