#include "../MessageMacros.h"
#include <string.h>
#include <stdio.h>
#include "AL3101PreAsm.h"
#include "AL3101Format.h"
#include "AL3101DbgFiles.h"

// creates and fills the Map structure from 
// the PAsmCst informations found in Preassembler
// For each ABS instruction <Name> (type CST_ABS), 
// we search an CST_EQU definition <IName>
// If this is not present, we set value to 0.
int GenerateMap(TMapItem **pMap){
  int n, i, j, nc, found;
  char InitVal[255];

  // browse the Constant table from PreAssembler
  // and calculate the number of addresses
  // no entry from the beginning
  n=0;
  for (i=0;i<AL3101PreAsmNbCst;i++){
    // check if this is a address definition
    if (AL3101PreAsmCstTable[i].Type==CST_ABS) n++;
  }

  (*pMap) = new TMapItem[n];

  // browse the Constant table from PreAssembler
  nc=0;
  for (i=0;i<AL3101PreAsmNbCst;i++){
    // check if this is a address definition
    if (AL3101PreAsmCstTable[i].Type==CST_ABS){
      // store name
      (*pMap)[nc].Name = new char[strlen(AL3101PreAsmCstTable[i].Name)+1];
      strcpy(AL3101PreAsmCstTable[i].Name, (*pMap)[nc].Name);

      // store address
      ExtractHexa(AL3101PreAsmCstTable[i].StrValue, 
		  &((*pMap)[nc].Address), 
		  NMANT_ADDR);

      // compute the constant name for init val
      sprintf(InitVal, "I%s", AL3101PreAsmCstTable[i].Name);
      // search this guy!
      found=0;
      for (j=0;j<AL3101PreAsmNbCst;j++){
	if ((AL3101PreAsmCstTable[j].Type==CST_EQU) 
	    && strcmp(AL3101PreAsmCstTable[j].Name, InitVal)==0){
	  // we have found a corresponding initial value
	  // it is supposed in S3.24 format !
	  found = 1-ExtractHexa(AL3101PreAsmCstTable[j].StrValue, 
				&((*pMap)[nc].Value), 
				24);
	}
      }
      if (!found) (*pMap)[nc].Value=0;
      nc++;
    }
  }

  return n;
}
