#ifndef __DISASM_FUNC_H__
#define __DISASM_FUNC_H__

#include "AL3101Struct.h"

//                                                                           3210987654321098765432109876543210
// normal mnemonics (no extrabit, no condition)
int disasm_c18_x_m(UINT32, UINT32, AL3101_Disasm_struct*, char*);    // CCCCCCCCCCCCCCCCCCCCCCXMMMMMMMMMMM
int disasm_x_m    (UINT32, UINT32, AL3101_Disasm_struct*, char*);    // XXXXXXXXXXXXXXXXXXXXXXXMMMMMMMMMMM
int disasm_c24_x  (UINT32, UINT32, AL3101_Disasm_struct*, char*);    // CCCCCCCCCCCCCCCCCCCCCCCCCCCCXXXXXX
int disasm_c18_x  (UINT32, UINT32, AL3101_Disasm_struct*, char*);    // CCCCCCCCCCCCCCCCCCCCCCXXXXXXXXXXXX
int disasm_c18_d8 (UINT32, UINT32, AL3101_Disasm_struct*, char*);    // CCCCCCCCCCCCCCCCCCCCCCDDDDDDDDDDDD
int disasm_c8_d18 (UINT32, UINT32, AL3101_Disasm_struct*, char*);    // CCCCCCCCCCCCDDDDDDDDDDDDDDDDDDDDDD
int disasm_x      (UINT32, UINT32, AL3101_Disasm_struct*, char*);    // XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

// mnemonics with condition
int disasm_c24_x_p(UINT32, UINT32, AL3101_Disasm_struct*, char*);    // CCCCCCCCCCCCCCCCCCCCCCCCCCCCXXPPPP
int disasm_c8_x_p (UINT32, UINT32, AL3101_Disasm_struct*, char*);    // CCCCCCCCXXXXXXXXXXXXXXXXXXXXXXPPPP

// mnemonics with extra bit
int disasm_c10_x_b_m(UINT32, UINT32, AL3101_Disasm_struct*, char*);  // CCCCCCCCCCXXXXXXXXXXXXbMMMMMMMMMMM
int disasm_c24_b_x  (UINT32, UINT32, AL3101_Disasm_struct*, char*);  // CCCCCCCCCCCCCCCCCCCCCCCCCCCC1XXXXX or
                                                                                 // XXXXXXXXXXXXXXXXXXXXXXXXXXXX0XXXXX

#endif
