#include "AL3101Table.h"

TMnemonicTable MnemonicTable[64] = {
  { 0,  "CM",    asm_c18_x_m,   disasm_c18_x_m,   _CM    },
  { 1,  "LCM",   asm_c18_x_m,   disasm_c18_x_m,   _LCM   },
  { 2,  "CMA",   asm_c18_x_m,   disasm_c18_x_m,   _CMA   },
  { 3,  "LCMA",  asm_c18_x_m,   disasm_c18_x_m,   _LCMA  },
  { 4,  "CMB",   asm_c18_x_m,   disasm_c18_x_m,   _CMB   },
  { 5,  "XCM",   asm_c18_x_m,   disasm_c18_x_m,   _XCM   },
  { 6,  "AMB",   asm_x_m,       disasm_x_m,       _AMB   },
  { 7,  "XCMA",  asm_c18_x_m,   disasm_c18_x_m,   _XCMA  },
  { 8,  "AMC",   asm_c18_x_m,   disasm_c18_x_m,   _AMC   },
  { 9,  "LAMC",  asm_c18_x_m,   disasm_c18_x_m,   _LAMC  },
  { 10, "BMC",   asm_c18_x_m,   disasm_c18_x_m,   _BMC   },
  { 11, "LMMC",  asm_c18_x_m,   disasm_c18_x_m,   _LMMC  },
  { 12, "MMC",   asm_c18_x_m,   disasm_c18_x_m,   _MMC   },
  { 13, "XMMC",  asm_c18_x_m,   disasm_c18_x_m,   _XMMC  },
  { 14, "1MC",   asm_c18_x_m,   disasm_c18_x_m,   _1MC   },
  { 15, "L1MC",  asm_c18_x_m,   disasm_c18_x_m,   _L1MC  },
  { 16, "AAC",   asm_c24_x,     disasm_c24_x,     _AAC   },
  { 17, "LAAC",  asm_c18_x_m,   disasm_c18_x_m,   _LAAC  },
  { 18, "BAC",   asm_c24_x,     disasm_c24_x,     _BAC   },
  { 19, "CAB",   asm_c18_x,     disasm_c18_x,     _CAB   },
  { 20, "CAD",   asm_c18_d8,    disasm_c18_d8,    _CAD   },
  { 21, "LCA",   asm_c18_x_m,   disasm_c18_x_m,   _LCA   },
  { 22, "CAM",   asm_c18_x_m,   disasm_c18_x_m,   _CAM   },
  { 23, "DAC",   asm_c8_d18,    disasm_c8_d18,    _DAC   },
  { 24, "BBC",   asm_c24_x,     disasm_c24_x,     _BBC   },
  { 25, "CB",    asm_c18_x,     disasm_c18_x,     _CB    },
  { 26, "CBM",   asm_c18_x_m,   disasm_c18_x_m,   _CBM   },
  { 27, "X1AC",  asm_c24_x,     disasm_c24_x,     _X1AC  },
  { 28, "1AC",   asm_c24_x,     disasm_c24_x,     _1AC   },
  { 29, "L1AC",  asm_c18_x_m,   disasm_c18_x_m,   _L1AC  },
  { 30, "LOGB",  asm_x,         disasm_x,         _LOGB  },
  { 31, "EXPB",  asm_x,         disasm_x,         _EXPB  },
  { 32, "SCA",   asm_c18_x_m,   disasm_c18_x_m,   _SCA   },
  { 33, "SXCA",  asm_c18_x_m,   disasm_c18_x_m,   _SXCA  },
  { 34, "SCB",   asm_c18_x_m,   disasm_c18_x_m,   _SCB   },
  { 35, "SBUA",  asm_x_m,       disasm_x_m,       _SBUA  },
  { 36, "SCUA",  asm_c18_x_m,   disasm_c18_x_m,   _SCUA  },
  { 37, "SCUB",  asm_c18_x_m,   disasm_c18_x_m,   _SCUB  },
  { 38, "SCU",   asm_c18_x_m,   disasm_c18_x_m,   _SCU   },
  { 39, "SBUC",  asm_c18_x_m,   disasm_c18_x_m,   _SBUC  },
  { 40, "SAAC",  asm_c18_x_m,   disasm_c18_x_m,   _SAAC  },
  { 41, "SXAAC", asm_c18_x_m,   disasm_c18_x_m,   _SXAAC },
  { 42, "SBAC",  asm_c18_x_m,   disasm_c18_x_m,   _SBAC  },
  { 43, "SBBC",  asm_c18_x_m,   disasm_c18_x_m,   _SBBC  },
  { 44, "SCBA",  asm_c18_x_m,   disasm_c18_x_m,   _SCBA  },
  { 45, "SCAB",  asm_c18_x_m,   disasm_c18_x_m,   _SCAB  },
  { 46, "SLOGB", asm_x_m,       disasm_x_m,       _SLOGB },
  { 47, "SEXPB", asm_x_m,       disasm_x_m,       _SEXPB },
  { 51, "SAUC",  asm_c18_x_m,   disasm_c18_x_m,   _SAUC  },
  { 52, "S1AC",  asm_c18_x_m,   disasm_c18_x_m,   _S1AC  },
  { 53, "SX1AC", asm_c18_x_m,   disasm_c18_x_m,   _SX1AC },
  { 54, "S1BC" , asm_c18_x_m,   disasm_c18_x_m,   _S1BC  },
  { 55, "SINDF", asm_c10_x_0_m, disasm_c10_x_b_m, _SINDF },
  { 55, "SINDI", asm_c10_x_1_m, disasm_c10_x_b_m, _SINDI },
  { 56, "ANDB",  asm_x_0_x,     disasm_c24_b_x,   _ANDB  },
  { 56, "ANDC",  asm_c24_1_x,   disasm_c24_b_x,   _ANDC  },
  { 57, "ADDB",  asm_x,         disasm_x,         _ADDB  },
  { 58, "SUBB",  asm_x,         disasm_x,         _SUBB  },
  { 59, "MLTB",  asm_x,         disasm_x,         _MLTB  },
  { 60, "C",     asm_c24_x_p,   disasm_c24_x_p,   _C     },
  { 61, "SKIP",  asm_c8_x_p,    disasm_c8_x_p,    _SKIP  },
  { 62, "1BC",   asm_c24_x,     disasm_c24_x,     _1BC   },
  { 63, "LINDF", asm_c10_x_0_m, disasm_c10_x_b_m, _LINDF },
  { 63, "LINDI", asm_c10_x_1_m, disasm_c10_x_b_m, _LINDI }
};

