// FileIO_PCM.h: interface for the PCM File functions.
//
//////////////////////////////////////////////////////////////////////

#ifndef __AL3101__FILEIO_PCM__H__
#define __AL3101__FILEIO_PCM__H__

#include <stdio.h>							// for the file IO
#include "../../../common/1K_types.h"		// for the simulator types
#include "./../FileIO_Generic.h"			// for the definition of the generic file IO stuff


//////////////////////////////////
// definition of the prototypes
//////////////////////////////////
// init & clean functions
INT32 FileIO_PCM_Init(void **pInst, CHAR *FileName, INT32 Mode, FileIO_SndCfg *cfg, INT32 *LeftSampleMemory, INT32 *RightSampleMemory = NULL);
INT32 FileIO_PCM_Clean(void *pInst);

// "processing" functions
INT32 FileIO_PCM_ReadSample(void *pInst);
INT32 FileIO_PCM_WriteSample(void *pInst);

// file functions
INT32 FileIO_PCM_GetPosition(void *pInstance, INT32 *CurrentPosition);
INT32 FileIO_PCM_GetFileLength(void *pInstance, INT32 *FileSize);

// control functions
INT32 FileIO_PCM_SetLoopingMode(void *pInst, INT32 Looping);

// text functions
void FileIO_PCM_GetLastErrorString(CHAR *str, INT32 LastErrorCode, INT32 MaxNumberOfCharacters);
void FileIO_PCM_GetHelp(CHAR *str, INT32 LineNumber, INT32 MaxNumberOfCharacters);


//////////////////////////////////
// defines PCM error messages
//////////////////////////////////
#define FILEIO_PCM_NOERROR					(FILEIO_PCM_BASE_ERR +  0)


#endif // !defined(__AL3101__FILEIO_PCM__H__)
