// Gen_TRI.h: interface for the Triangle generator functions.
//
///////////////////////////////////////////////////////////////////////////

#ifndef __AL3101__GEN_TRI__H__
#define __AL3101__GEN_TRI__H__

#include <stdio.h>						// for the file IO
#include "../../common/1K_types.h"		// for the simulator types
#include "./../FileIO/FileIO_Generic.h"	// for the definition of the generic file IO stuff

// Configuration structure containing the parameters. To be used at init time.
typedef struct Generator_TriCfg_structtag
{
	float SamplingFrequency;
	float SineFrequency;
	float Amplitude;
	float Offset;
	float OriginalPhase;
	int Mode;
} Generator_TriCfg;


//////////////////////////////////
// definition of the prototypes
//////////////////////////////////
// init & clean functions
INT32 Gen_TRI_Init(void **pInstance, Generator_TriCfg *cfg, INT32 *InputMemory);
INT32 Gen_TRI_Clean(void *pInstance);

// "processing" functions
INT32 Gen_TRI_ReadSample(void *pInstance);

// file-like functions
INT32 Gen_TRI_GetPosition(void *pInstance, INT32 *CurrentPosition);
INT32 Gen_TRI_GetFileLength(void *pInstance, INT32 *FileSize);

// control functions
INT32 Gen_TRI_SetLoopingMode(void *pInst, INT32 Looping);

// text functions
//VOID FileIO_PCM_GetLastErrorString(CHAR *str, INT32 LastErrorCode, INT32 MaxNumberOfCharacters);
//VOID FileIO_PCM_GetHelp(CHAR *str, INT32 LineNumber, INT32 MaxNumberOfCharacters);

//////////////////////////////////
// defines PCM error messages
//////////////////////////////////
//#define FILEIO_PCM_NOERROR					(FILEIO_PCM_BASE_ERR +  0)


#endif // !defined(__AL3101__GEN_TRI__H__)

