// Gen_WNO.h: interface for the White noise generator functions.
//
///////////////////////////////////////////////////////////////////////////

#ifndef __AL3101__GEN_WNO__H__
#define __AL3101__GEN_WNO__H__

#include <stdio.h>						// for the file IO
#include "../../common/1K_types.h"		// for the simulator types
#include "./../FileIO/FileIO_Generic.h"	// for the definition of the generic file IO stuff

// Configuration structure containing the parameters. To be used at init time.
typedef struct Generator_WhiteNoiseCfg_structtag
{
	float Amplitude;
	float Offset;
} Generator_WhiteNoiseCfg;


//////////////////////////////////
// definition of the prototypes
//////////////////////////////////
// init & clean functions
INT32 Gen_WNO_Init(void **pInstance, Generator_WhiteNoiseCfg *cfg, INT32 *InputMemory);
INT32 Gen_WNO_Clean(void *pInstance);

// "processing" functions
INT32 Gen_WNO_ReadSample(void *pInstance);

// file-like functions
INT32 Gen_WNO_GetPosition(void *pInstance, INT32 *CurrentPosition);
INT32 Gen_WNO_GetFileLength(void *pInstance, INT32 *FileSize);

// control functions
INT32 Gen_WNO_SetLoopingMode(void *pInst, INT32 Looping);

// text functions
//VOID FileIO_PCM_GetLastErrorString(CHAR *str, INT32 LastErrorCode, INT32 MaxNumberOfCharacters);
//VOID FileIO_PCM_GetHelp(CHAR *str, INT32 LineNumber, INT32 MaxNumberOfCharacters);

//////////////////////////////////
// defines PCM error messages
//////////////////////////////////
//#define FILEIO_PCM_NOERROR					(FILEIO_PCM_BASE_ERR +  0)


#endif // !defined(__AL3101__GEN_WNO__H__)

