// Tool_FrequencyResponse.h: interface for the FrequencyResponse Tool functions.
//
/////////////////////////////////////////////////////////////////////////////////

#ifndef __AL3101__TOOL_FREQRESP__H__
#define __AL3101__TOOL_FREQRESP__H__

#include <stdio.h>							// for the file IO
#include "../../common/1K_types.h"	// for the simulator types
//#include "FileIO_Generic.h"				// for the definition of the generic file IO stuff

// Timing parameter structure. To be used at init time.
typedef struct Tool_FreqResp_Parameters_structtag
{
	// "Timing" related parameters
	INT32 BlockSize;
	INT32 NSkipBlocks;
	float SamplingFrequency;
	// "Level" related parameter
	float NoiseLevel;
} Tools_FreqResp_Parameters;

// Results structure.
typedef struct Tool_FreqResp_Results_structtag
{
	float Frequency;
	float Amplitude;
	float Phase;
} Tool_FreqResp_Results;


//////////////////////////////////
// definition of the prototypes
//////////////////////////////////
// init & clean functions
INT32 Tool_FreqResp_Init(void **pInstance, Tool_FreqResp_Results *results, Tools_FreqResp_Parameters *Params, INT32 *InputMemory, INT32 *OutputMemory, CHAR *AmplitudeFileName, CHAR *PhaseFileName);
INT32 Tool_FreqResp_Clean(void *pInstance);

// "processing" functions
INT32 Tool_FreqResp_ReadSample(void *pInstance);
INT32 Tool_FreqResp_WriteSample(void *pInstance);

// file-like functions
INT32 Tool_FreqResp_GetPosition(void *pInstance, INT32 *CurrentPosition);
INT32 Tool_FreqResp_GetFileLength(void *pInstance, INT32 *FileSize);

// control functions

// text functions
//VOID FileIO_PCM_GetLastErrorString(CHAR *str, INT32 LastErrorCode, INT32 MaxNumberOfCharacters);
//VOID FileIO_PCM_GetHelp(CHAR *str, INT32 LineNumber, INT32 MaxNumberOfCharacters);


//////////////////////////////////
// defines PCM error messages
//////////////////////////////////
//#define FILEIO_PCM_NOERROR					(FILEIO_PCM_BASE_ERR +  0)


#endif // !defined(__AL3101__TOOL_FREQRESP__H__)

